import 'package:flutter/material.dart';
import 'package:flutter_svg/flutter_svg.dart';

class AppIcons {
  static final AppIcons _icons = AppIcons._internal();

  factory AppIcons() => _icons;

  AppIcons._internal();

  final basePath = 'assets/icons';

  Widget copyToClipboard({double? width, double? height, Color? color}) =>
      SvgPicture.asset('$basePath/ico_copy_to_clipboard.svg',
          width: width, height: height, color: color);

  Widget arrowRight({double? width, double? height, Color? color}) =>
      SvgPicture.asset('$basePath/ico_arrow_right.svg',
          width: width, height: height, color: color);

  Widget arrowDown({double? width, double? height, Color? color}) =>
      SvgPicture.asset('$basePath/ico_arrow_down.svg',
          width: width, height: height, color: color);

  Widget arrowLong({double? width, double? height, Color? color}) =>
      SvgPicture.asset('$basePath/ico_arrow_long.svg',
          width: width, height: height, color: color);

  Widget arrow({double? width, double? height, Color? color}) =>
      SvgPicture.asset('$basePath/ico_arrow.svg',
          width: width, height: height, color: color);

  Widget arrowLeft({double? width, double? height, Color? color}) =>
      SvgPicture.asset('$basePath/ico_arrow_left.svg',
          width: width, height: height, color: color);

  Widget arrowTopRight({double? width, double? height, Color? color}) =>
      SvgPicture.asset('$basePath/ico_arrow_top_right.svg',
          width: width, height: height, color: color);

  Widget checkmark({double? width, double? height, Color? color}) =>
      SvgPicture.asset('$basePath/ico_check.svg',
          width: width, height: height, color: color);

  Widget plus({double? width, double? height, Color? color}) =>
      SvgPicture.asset('$basePath/ico_plus.svg',
          width: width, height: height, color: color);

  Widget delete({double? width, double? height, Color? color}) =>
      SvgPicture.asset('$basePath/ico_delete.svg',
          width: width, height: height, color: color);

  Widget back({double? width, double? height, Color? color}) =>
      SvgPicture.asset('$basePath/ico_back.svg',
          width: width, height: height, color: color);

  Widget key({double? width, double? height, Color? color}) =>
      SvgPicture.asset('$basePath/ico_key.svg',
          width: width, height: height, color: color);

  Widget logOut({double? width, double? height, Color? color}) =>
      SvgPicture.asset('$basePath/ico_log_out.svg',
          width: width, height: height, color: color);

  Widget breadCrumbsLine({double? width, double? height, Color? color}) =>
      SvgPicture.asset('$basePath/ico_brcmb_line.svg',
          width: width, height: height, color: color);

  Widget loader({double? width, double? height, Color? color}) =>
      SvgPicture.asset('$basePath/ico_loader.svg',
          width: width, height: height, color: color);

  Widget hamburger({double? width, double? height, Color? color}) =>
      SvgPicture.asset('$basePath/ico_hamburger.svg',
          width: width, height: height, color: color);

  Widget close({double? width, double? height, Color? color}) =>
      SvgPicture.asset('$basePath/ico_close.svg',
          width: width, height: height, color: color);

  Widget rotateCCW({double? width, double? height, Color? color}) =>
      SvgPicture.asset('$basePath/ico_rotate_ccw.svg',
          width: width, height: height, color: color);

  Widget ignore({double? width, double? height, Color? color}) =>
      SvgPicture.asset('$basePath/ico_ignore.svg',
          width: width, height: height, color: color);

  Widget check({double? width, double? height, Color? color}) =>
      SvgPicture.asset('$basePath/ico_check.svg',
          width: width, height: height, color: color);

  Widget duplicate({double? width, double? height, Color? color}) =>
      SvgPicture.asset('$basePath/ico_duplicate.svg',
          width: width, height: height, color: color);

  Widget log_out_rotated({double? width, double? height, Color? color}) =>
      SvgPicture.asset('$basePath/ico_log_out_rotated.svg',
          width: width, height: height, color: color);

  Widget x({double? width, double? height, Color? color}) =>
      SvgPicture.asset('$basePath/ico_x.svg',
          width: width, height: height, color: color);

  Widget gitlab({double? width, double? height, Color? color}) =>
      SvgPicture.asset('$basePath/gitlab.svg',
          width: width, height: height, color: color);

  Widget twitter({double? width, double? height, Color? color}) =>
      SvgPicture.asset('$basePath/twitter.svg',
          width: width, height: height, color: color);
}
