import 'dart:async';

import 'package:flutter/material.dart';
import 'package:memri/constants/app_logger.dart';
import 'package:memri/locator.dart' as locator;
import 'package:memri/memri.dart';

import 'configs/configure_none_web.dart'
    if (dart.library.html) 'configs/configure_web.dart';
import 'core/services/analytics_service.dart';

void main() {
  configureApp();
  runZonedGuarded(() async {
    WidgetsFlutterBinding.ensureInitialized();
    locator.setup();
    await AnalyticsService().init();
    runApp(Memri());
  }, (error, stackTrace) async {
    AppLogger.err(error.toString(),
        stackTrace: stackTrace, sendCrashReport: true);
    throw error;
  });
}
