import 'package:flutter/material.dart';
import 'package:memri/providers/oauth_provider.dart';
import 'package:memri/widgets/importer/importer_connect_twitter.dart';
import 'package:memri/widgets/importer/importer_connect_whatsapp.dart';
import 'package:memri/widgets/scaffold/workspace_scaffold.dart';
import 'package:provider/provider.dart';

class ImporterConnectScreen extends StatefulWidget {
  const ImporterConnectScreen({Key? key, required this.name}) : super(key: key);

  final String name;

  @override
  State<ImporterConnectScreen> createState() => _ImporterConnectScreenState();
}

class _ImporterConnectScreenState extends State<ImporterConnectScreen> {
  late final _oauthProvider =
      Provider.of<OAuthProvider>(context, listen: false);
  Widget? _body;

  @override
  void initState() {
    if (widget.name == 'whatsapp') {
      _oauthProvider.initWhatsappOauth(context);
      _body = ImporterConnectWhatsapp();
    } else if (widget.name == 'twitter') {
      _body = ImporterConnectTwitter(parentContext: context);
    }
    super.initState();
  }

  @override
  void dispose() {
    if (widget.name == 'whatsapp') {
      _oauthProvider.cancelWhatsappStreamSubs();
    }
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    return WorkspaceScaffold(
      currentItem: NavigationItem.data,
      child: SingleChildScrollView(
        child: Container(
          width: MediaQuery.of(context).size.width,
          padding: EdgeInsets.all(30),
          child: _body ?? SizedBox(),
        ),
      ),
    );
  }
}
