import 'package:flutter/material.dart';
import 'package:memri/constants/app_styles.dart';
import 'package:memri/providers/data_app_provider.dart';
import 'package:provider/provider.dart';

class DataAppLogs extends StatelessWidget {
  const DataAppLogs(
      {Key? key, required this.currentRunLog, this.backgroundColor})
      : super(key: key);

  final String? currentRunLog;
  final Color? backgroundColor;

  @override
  Widget build(BuildContext context) {
    return Consumer<DataAppProvider>(builder: (context, provider, _) {
      return Container(
        constraints: BoxConstraints(minHeight: 256),
        width: MediaQuery.of(context).size.width,
        color: backgroundColor,
        child: Padding(
          padding: EdgeInsets.all(30),
          child: SelectableText(
            currentRunLog ?? 'Fetching run logs...',
            style: AppStyles.code.copyWith(fontSize: 12),
          ),
        ),
      );
    });
  }
}
