import 'package:flutter/material.dart';
import 'package:memri/constants/app_styles.dart';
import 'package:memri/utilities/helpers/app_helper.dart';

class DataAppRow extends StatelessWidget {
  const DataAppRow({
    Key? key,
    required this.content,
    required this.date,
    required this.label,
    required this.labelColor,
  }) : super(key: key);

  final String date;
  final String content;
  final String label;
  final Color labelColor;

  @override
  Widget build(BuildContext context) {
    return ListTile(
      dense: true,
      minVerticalPadding: 0,
      contentPadding: EdgeInsets.zero,
      title: Text(
        content,
        style: AppStyles.bodyText1,
        maxLines: 5,
      ),
      subtitle: Text(date,
          style: AppStyles.bodyTiny.copyWith(color: app.colors.brandGreyText)),
      trailing: Chip(
        label: Text(
          label,
          style: AppStyles.bodyText1.copyWith(color: app.colors.white),
        ),
        backgroundColor: labelColor,
        padding: EdgeInsets.symmetric(horizontal: 10, vertical: 5),
      ),
    );
  }
}
