import 'package:flutter/material.dart';
import 'package:memri/utilities/helpers/app_helper.dart';

class ImporterInfoLine extends StatelessWidget {
  const ImporterInfoLine(
      {Key? key, required this.weights, required this.contents})
      : super(key: key);

  final List<FontWeight> weights;
  final List<String> contents;

  @override
  Widget build(BuildContext context) {
    return Wrap(
      crossAxisAlignment: WrapCrossAlignment.center,
      children: [
        app.icons.arrowTopRight(color: app.colors.brandGreyText),
        SizedBox(width: 12),
        for (int i = 0; i < contents.length; i++)
          Text(contents[i],
              style: TextStyle(fontSize: 14, fontWeight: weights[i]))
      ],
    );
  }
}
