import 'package:flutter/material.dart';
import 'package:memri/configs/routes/route_navigator.dart';
import 'package:memri/constants/app_styles.dart';
import 'package:memri/localization/generated/l10n.dart';
import 'package:memri/utilities/helpers/app_helper.dart';
import 'package:memri/widgets/scaffold/workspace_scaffold.dart';

class BottomBar extends StatelessWidget {
  const BottomBar({Key? key, required this.currentItem}) : super(key: key);

  final NavigationItem currentItem;

  @override
  Widget build(BuildContext context) {
    return Container(
      height: kBottomNavigationBarHeight,
      color: app.colors.black,
      padding: EdgeInsets.all(8),
      child: Row(
        children: [
          Spacer(),
          TextButton(
            onPressed: () => RouteNavigator.navigateTo(
                context: context, route: Routes.workspace, clearStack: true),
            child: Text(
              S.current.workspace,
              style: AppStyles.bodyText1.copyWith(
                  color: currentItem == NavigationItem.workspace
                      ? app.colors.primary
                      : app.colors.white),
            ),
          ),
          Spacer(),
          VerticalDivider(color: app.colors.white.withOpacity(0.4)),
          Spacer(),
          TextButton(
            onPressed: () =>
                RouteNavigator.navigateTo(context: context, route: Routes.data),
            child: Text(
              S.current.data,
              style: AppStyles.bodyText1.copyWith(
                  color: currentItem == NavigationItem.data
                      ? app.colors.primary
                      : app.colors.white),
            ),
          ),
          Spacer(),
          VerticalDivider(color: app.colors.white.withOpacity(0.4)),
          Spacer(),
          TextButton(
            onPressed: () => RouteNavigator.navigateTo(
                context: context, route: Routes.projects),
            child: Text(
              S.current.projects,
              style: AppStyles.bodyText1.copyWith(
                  color: currentItem == NavigationItem.projects
                      ? app.colors.primary
                      : app.colors.white),
            ),
          ),
          Spacer(),
          VerticalDivider(color: app.colors.white.withOpacity(0.4)),
          Spacer(),
          TextButton(
            onPressed: () =>
                RouteNavigator.navigateTo(context: context, route: Routes.apps),
            child: Text(
              S.current.apps,
              style: AppStyles.bodyText1.copyWith(
                  color: currentItem == NavigationItem.apps
                      ? app.colors.primary
                      : app.colors.white),
            ),
          ),
          Spacer(),
        ],
      ),
    );
  }
}
