import 'package:flutter_test/flutter_test.dart';
import 'package:memri/core/apis/gitlab_api.dart';

void main() {
  group('GitlabAPI getTextFile', () {
    // There is a risk of these tests failing if the file or project removed or modified.
    const projectPath = 'memri/pymemri';
    const branch = 'dev';
    const projectId = 80;
    const testPath = 'setup.py';
    final api = GitlabAPI();

    test('works with projectPath', () async {
      final fileContent = await api.getTextFile(
          projectPath: projectPath, filepath: testPath, branch: branch);
      expect(fileContent, isNotEmpty);
    });

    test('works with projectId', () async {
      final fileContent = await api.getTextFile(
          projectId: projectId, filepath: testPath, branch: branch);
      expect(fileContent, isNotEmpty);
    });

    test('throws if projectPath and projectId are both null', () async {
      expect(
          () => api.getTextFile(
              projectPath: null,
              projectId: null,
              filepath: testPath,
              branch: branch),
          throwsArgumentError);
    });
  });
}
